<?php

$kv=array();
$t_checkout=60;
$timeout=600;
$port=9991;


$server = new swoole_server('0.0.0.0', $port, SWOOLE_PROCESS, SWOOLE_SOCK_UDP);
$server->set(['worker_num' => 1]);
$server->set(['daemonize' => 1]);

function update_mac($data)
{
    $l_str=date("Y-m-d H:i:s")." ".$data;
    error_log($l_str."\r\n",3,'/tmp/message1.log');
}


$server->on('Packet', function (swoole_server $serv, $data, $addr) {
    $a = explode("\n", $data);


    $num = count($a) - 1;

    for ($i = 1; $i < $num; $i++) {
        update_mac( $a[$i]);
    }
    $serv->sendto($addr['address'], $addr['port'], '1');

});

function check_timeout($tm)
{
    global $kv;
    global $timeout;
    $t=time();

    foreach($kv as $k=>$item){

        $t1=$item['t'];

        if($t>$t1){
            $t1=$t1-$timeout;
            $ts=date("Y-m-d H:i:s",$t1);

            unset($kv[$k]);
        }
    }
}
$server->on('WorkerStart', function ($serv, $worker_id){


});
$server->start();

?>
